Re: 'git commit' duplicates parents?
- From
Dan Holmsand <holmsand@gmail.com>
- Date
- Jun 20, 2005, 18:52 UTC
- Message-ID
- <42B71076.1050904@gmail.com>
- In-Reply-To
- <Pine.LNX.4.58.0506201040140.2268@ppc970.osdl.org>
Linus Torvalds wrote:
Show 5 quoted lines
> > [ Side note: I should make "git-resolve-script" run "git-rev-parse" on its > arguments, so that it would expand HEAD and MERGE_HEAD on its own. Maybe > somebody who is interested in this script might want to do that? Hint > hint. ]
Got it. Included below.
> Note how we could make both of us happy by saving that temporary > MERGE_HEAD information somewhere _else_ instead. Maybe the answer is to > only use "MERGE_HEAD" for the "merge manually" case, and use something > else for the "this was the merge you tried to do last" case?
I like the "everybody happy" idea...
How about "LAST_MERGE"? And something like this?
/dan
---
[PATCH] git-resolve-script: Add LAST_MERGE and use git-rev-parse
Make git-resolve-script only write MERGE_HEAD if a merge actually occurred. All merge failures leave ORIG_HEAD and LAST_MERGE behind (instead of ORIG_HEAD and MERGE_HEAD).
Use git-rev-parse to expand arguments (and check for bad ones).
Signed-off-by: Dan Holmsand <holmsand@gmail.com>
diff --git a/git-resolve-script b/git-resolve-script --- a/git-resolve-script +++ b/git-resolve-script @@ -4,26 +4,31 @@ # # Resolve two trees. # -head="$1" -merge="$2" +head=$(git-rev-parse --revs-only "$1") +merge=$(git-rev-parse --revs-only "$2") merge_repo="$3" : ${GIT_DIR=.git} : ${GIT_OBJECT_DIRECTORY="${SHA1_FILE_DIRECTORY-"$GIT_DIR/objects"}"} -rm -f "$GIT_DIR"/MERGE_HEAD "$GIT_DIR"/ORIG_HEAD -echo $head > "$GIT_DIR"/ORIG_HEAD -echo $merge > "$GIT_DIR"/MERGE_HEAD +dropheads() { + rm -f -- "$GIT_DIR/ORIG_HEAD" "$GIT_DIR/MERGE_HEAD" \ + "$GIT_DIR/LAST_MERGE" || exit 1 +} # # The remote name is just used for the message, # but we do want it. # -if [ "$merge_repo" == "" ]; then +if [ -z "$head" -o -z "$merge" -o -z "$merge_repo" ]; then echo "git-resolve-script <head> <remote> <merge-repo-name>" exit 1 fi +dropheads +echo $head > "$GIT_DIR"/ORIG_HEAD +echo $merge > "$GIT_DIR"/LAST_MERGE + common=$(git-merge-base $head $merge) if [ -z "$common" ]; then echo "Unable to find common commit between" $merge $head @@ -32,7 +37,7 @@ fi if [ "$common" == "$merge" ]; then echo "Already up-to-date. Yeeah!" - rm -f -- "$GIT_DIR/ORIG_HEAD" "$GIT_DIR/MERGE_HEAD" + dropheads exit 0 fi if [ "$common" == "$head" ]; then @@ -40,7 +45,7 @@ if [ "$common" == "$head" ]; then git-read-tree -u -m $head $merge || exit 1 echo $merge > "$GIT_DIR"/HEAD git-diff-tree -p ORIG_HEAD HEAD | git-apply --stat - rm -f -- "$GIT_DIR/ORIG_HEAD" "$GIT_DIR/MERGE_HEAD" + dropheads exit 0 fi echo "Trying to merge $merge into $head" @@ -51,6 +56,7 @@ if [ $? -ne 0 ]; then echo "Simple merge failed, trying Automatic merge" git-merge-cache -o git-merge-one-file-script -a if [ $? -ne 0 ]; then + echo $merge > "$GIT_DIR"/MERGE_HEAD echo "Automatic merge failed, fix up by hand" exit 1 fi @@ -60,4 +66,4 @@ result_commit=$(echo "$merge_msg" | git- echo "Committed merge $result_commit" echo $result_commit > "$GIT_DIR"/HEAD git-diff-tree -p $head $result_commit | git-apply --stat -rm -f -- "$GIT_DIR/ORIG_HEAD" "$GIT_DIR/MERGE_HEAD" +dropheads